#############################################################################
# Share value corresponding to the last Monday of August 1991
# (26/08/91) removed from Buckle (1995) dataset (cf. Bank holiday in England)
# In Buckle, it was just set equal to the last closing value of the share,
# i.e. the one recorded on Friday 23/08/91 ==> not a real datum.
#############################################################################

library(stable)

y <- c(296,296,300,302,300,304,303,299,293,294,294,293,295,287,288,297,305,
307,304,303,304,304,309,309,309,307,306,304,300,296,301,298,295,
295,293,292,297,294,293,306,303,301,303,308,305,302,301,297,299)
ret <- (y[2:49]-y[1:48])/y[1:48]

if(interactive()){
hist(ret, breaks=seq(-0.035,0.045,0.01))
}

tim <-
c(0.00,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09,0.10,0.11,0.12,0.13,0.14,
0.15,0.16,0.17,0.18,0.19,0.20,0.21,0.22,0.23,0.24,0.25,0.26,0.27,0.28,0.29,
0.30,0.31,0.32,0.33,0.34,0.35,0.36,0.37,0.38,0.39,0.40,0.41,0.42,0.43,0.44,
0.45,0.46,0.47)
tim2 <- tim*tim

idx <- 1:48
x <- idx-1

x <- seq(1,length(ret))-1
retlag1 <- c(0,ret[1:47])

print(z1 <- stablereg(ret, delta=1/y[1:48], loc=0.00169, disp=log(0.0079),
	skew=skew.g(-0.816), tail=tail.g(1.55), noopt=T))

print(z2 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1,
	skew=~1, tail=~1, iloc=0.15554, idisp=-4.8, iskew=-2.24593,
	itail=1.18))
exp(z2$coef[2])
2/(1+exp(-z2$coef[3]))-1
2/(1+exp(-z2$coef[4]))

print(z3 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1,
	skew=~1, tail=~1, iloc=c(0.005,-0.01), idisp=-4.8,
	iskew=-2.0, itail=0.65))

print(z4 <- stablereg(ret, delta=1/y[1:48], loc=~tim+tim2, disp=~1,
	skew=~1, tail=~1, iloc=c(0.15554,0,0), idisp=-4.8,
	iskew=-2.24593, itail=0.64))

print(z5 <- stablereg(ret, delta=1/y[1:48], loc=~tim+retlag1, disp=~1,
	skew=~1, tail=~1, iloc=c(0.008,-0.018,-0.058), idisp=-4.8,
	iskew=-2, itail=0.65))

print(z6 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1, skew=~1,
	tail=~1, iloc=c(-0.07280366,0.1904735), idisp=-3.633529,
	iskew=skew.g(0), itail=0.64, oskew=F))

print(z7 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~1,
	tail=tail.g(1.9999999), iloc=-0.00003198, idisp=-4.68,
	iskew=2.123199, otail=F, oskew=F))

glm(ret~1)

if(interactive()){
plot(x,ret,xlab="Day",ylab="Share return",xlim=c(0,50))
lines(x,z3$loc,lty="dashed") # Fitted loc
lines(x,z8$loc,lty="solid") # Fitted normal
xx <- c(x[1],x[48])
zz <- c(z2$loc[1],z2$loc[48])
lines(xx,zz)
}

print(z8 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1, skew=~1,
	tail=tail.g(1.999999), iloc=c(0,0), idisp=-4.8, iskew=-1.96859,
	oskew=F, otail=F))

print(z9 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~tim, skew=~1,
	tail=~1, iloc=0.001, idisp=c(-4.0,0), iskew=-2.24593, itail=1.5))

print(z10 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~tim,
	tail=~1, iloc=0.0005906, idisp=-4.946, iskew=c(2.80965,-21.58217),
	itail=0.78))

print(z11 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~1,
	tail=~tim, iloc=0.0019, idisp=-4.77, iskew=-2,
	itail=c(2.36,-4)))

print(z12 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1, skew=~tim,
	tail=~1, iloc=c(0.03125,0), idisp=-4.9,
	iskew=c(2.80091,-21.55992), itail=1.5))

print(z13 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~tim,
	tail=~tim, iloc=0.00044, idisp=-4.94, iskew=c(2.80091,-21.55992),
	itail=c(1,-0.9)))

print(z14 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~tim, skew=~1,
	tail=~tim, iloc=0.0017, idisp=c(-4.8,0), iskew=-2.3,
	itail=c(2.34,-3.92)))

print(z15 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~tim, skew=~1,
	tail=~1, iloc=c(0.15554,0), idisp=c(-4.8,0), iskew=-2.24593,
	itail=1.15))

print(z16 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1, skew=~1,
	tail=~tim, iloc=c(0.007,-0.016), idisp=-4.82, iskew =-2.1,
	itail=c(0.71,-0.3)))

if(interactive()){

#######################################################################
# Figure 1 in the text: regression of loc on time with 10% lik borders
# + normal fit
#######################################################################

mode <- stable.mode(loc=z3$loc,disp=z3$disp,skew=z3$skew,
	tail=z3$tail)$ytilde

y.r10 <- rep(0,length(ret))
y.r90 <- rep(0,length(ret))
f10 <- function(y)dstable(y=y,loc=z3$loc[i],disp=z3$disp[i],
	skew=z3$skew[i],tail=z3$tail[i])/
	dstable(y=mode[i],loc=z3$loc[i],disp=z3$disp[i],
	skew=z3$skew[i],tail=z3$tail[i])-0.1
for(i in 1:length(ret)){
	y.r10[i] <- uniroot(f10,c(-0.5,0))$root
	y.r90[i] <- uniroot(f10,c(0,0.5))$root
	cat(c(i,y.r10[i],y.r90[i]),"\n")}

postscript(file="fitb.eps",horizontal=F,width=8,height=6)
plot(x,ret,xlab="Day",ylab="Share return",pch=4,type="n",xlim=c(0,50))
out.idx <- which(abs(ret)>0.016)
not.out.idx <- which((!abs(ret)>0.016))
points(x[not.out.idx],ret[not.out.idx])
points(x[out.idx],ret[out.idx],pch="0")

lines(x,mode,lty="solid")
lines(x,y.r10,lty="dotted")
lines(x,y.r90,lty="dotted")
lines(x,z8$loc,lty="dashed") # Fitted normal
dev.off()

#######################################################################
# Figure 3 in the text: regression of skew on time with 10% lik borders
#######################################################################

mode <- stable.mode(loc=z10$loc,disp=z10$disp,skew=z10$skew,
	tail=z10$tail)$ytilde

y.r10 <- rep(0,length(ret))
y.r90 <- rep(0,length(ret))
f10 <- function(y)dstable(y=y,loc=z10$loc[i],disp=z10$disp[i],
	skew=z10$skew[i],tail=z10$tail[i])/
	dstable(y=mode[i],loc=z10$loc[i],disp=z10$disp[i],
	skew=z10$skew[i],tail=z10$tail[i])-0.1
for(i in 1:length(ret)){
	y.r10[i] <- uniroot(f10,c(-0.5,0))$root
	y.r90[i] <- uniroot(f10,c(0,0.5))$root
	cat(c(i,y.r10[i],y.r90[i]),"\n")}

postscript(file="fit2b.eps.eps",width=8,height=6)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(x,ret,xlab="Day",ylab="Share return",pch=4,type="n",xlim=c(0,50))
out.idx <- which(abs(ret)>0.016)
not.out.idx <- which((!abs(ret)>0.016))
points(x[not.out.idx],ret[not.out.idx])
points(x[out.idx],ret[out.idx],pch="0")
lines(x,mode)
lines(x,y.r10,lty="dotted")
lines(x,y.r90,lty="dotted")
dev.off()

#######################################################################
# Figure 2 in the text: profile likelihoods for the parameters of the
# stationary model
#######################################################################

# Computation of a the relative profile likelihood for the
# location parameter in the stationary stable model

dev.opt <- z2$llik
ig <- z2$coef[1]
id <- z2$coef[2]
ib <- z2$coef[3]
ia <- z2$coef[4]

gamm <- c(seq(-0.005,0.000,by=0.001),seq(0.0005,0.0040,by=0.0005),
	seq(0.005,0.010,by=0.001))
gamm.relative.lik <- 0*gamm

for(i in 1:length(gamm)){
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=gamm[i], disp=~1, skew=~1, tail=~1,
		oloc=F, idisp=id, iskew=ib, itail=ia, hessian=F,
		integration="Simpson")
	ddev <- tamp$llik-dev.opt  # dev.opt is the -llik at gamm.hat
				   # ddev is the difference in -llik
	gamm.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat(i,") loc=",gamm[i],"  R=",gamm.relative.lik[i],"\n")}

plot(gamm,gamm.relative.lik,type="l",xlab=expression(gamma),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# dispersion parameter in the stationary stable model

delta <- c(seq(0.004,0.00751,by=0.0005),disp.h(z2$coef[2]),0.0080,0.0085,
	seq(0.009,0.018,by=0.001))
delta.relative.lik <- 0*delta

for(i in 1:length(delta)){
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=~1, disp=disp.g(delta[i]), skew=~1, tail=~1,
		odisp=F, iloc=ig, iskew=ib, itail=ia, hessian=F,
		integration="Simpson")
	delta.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat(i,") disp=",delta[i],"  R=",delta.relative.lik[i],"\n")}

plot(delta,delta.relative.lik,type="l",xlab=expression(delta),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# skew parameter in the stationary stable model

beta <- c(seq(-0.99,-0.69,by=0.01),seq(-0.7,0.5,by=0.1))
beta.relative.lik <- 0*beta

for(i in 1:length(beta)){
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=~1, disp=~1, skew=skew.g(beta[i]), tail=ret~1,
		oskew=F, iloc=ig, idisp=id, itail=ia, hessian=F,
		integration="Simpson")
	beta.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat(i,") skew=",beta[i],"  R=",beta.relative.lik[i],"\n")}

plot(beta,beta.relative.lik,type="l",xlab=expression(beta),xlim=c(-1,0.3),
     ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# tail parameter in the stationary stable model

alpha <- c(seq(1.2,1.51,by=0.05),tail.h(z2$coef[4]),seq(1.55,2.01,by=0.05))
alpha.relative.lik <- 0*alpha

for(i in 1:length(alpha)){
	tamp <- stablereg(ret,delta=1/y[1:48],
		loc=~1, disp=~1, skew=~1, tail=tail.g(alpha[i]),
		otail=F, iloc=ig, idisp=id, iskew=ib, hessian=F,
		integration="Simpson")
	alpha.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat(i,") tail=",alpha[i],"  R=",alpha.relative.lik[i],"\n")}

plot(alpha,alpha.relative.lik,type="l",xlab=expression(alpha),
	ylab="Normed profile likelihood")

postscript(file="profileb.eps",width=6,height=6)
par(mfrow=c(2,2),mar=c(5,3,2,2))
plot(alpha,alpha.relative.lik,type="l",xlab=expression(alpha),ylab="")
plot(beta[-38],beta.relative.lik[-38],type="l",
	xlab=expression(paste(beta,"'")),ylab="",xlim=c(-1,0.3))
plot(gamm,gamm.relative.lik,type="l",xlab=expression(gamma),ylab="")
plot(delta[-(12:14)],delta.relative.lik[-(12:14)],type="l",
	xlab=expression(paste(delta,"'")),ylab="", xlim=c(0.005,0.016))
dev.off()

#######################################################################
# Figure 4 in the text: profile likelihoods for the parameters of the
# model with skew depending on time
#######################################################################

dev.opt <- z10$llik
ig <- z10$coef[1]
id <- z10$coef[2]
ib <- z10$coef[3:4]
ia <- z10$coef[5]

# Computation of a the relative profile likelihood for the
# location parameter in the final model.

gamm <- c(seq(-0.005,0.000,by=0.001),seq(0.0005,0.0009,by=0.0001),
	seq(0.0010,0.010,by=0.001))
gamm.relative.lik <- 0*gamm

for(i in 1:length(gamm)){
	cat(i,") loc=",gamm[i])
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=gamm[i], disp=~1, skew=~tim, tail=~1,
		oloc=F, idisp=id, iskew=ib, itail=ia, hessian=F,
		integration="Simpson")
	ddev <- tamp$llik-dev.opt  # dev.opt is the -llik at gamm.hat
				   # ddev is the difference in -llik
	gamm.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat("  R=",gamm.relative.lik[i],"\n")}

plot(gamm,gamm.relative.lik,type="l",xlab=expression(gamma),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# dispersion parameter in the final model.

delta <- c(seq(0.005,0.0098,by=0.0002))
delta.relative.lik <- 0*delta

for(i in 1:length(delta)){
	cat(i,") disp=",delta[i])
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=~1, disp=~1, skew=~tim, tail=~1,
		odisp=F, iloc=ig, iskew=ib, idisp=disp.g(delta[i]),
		itail=ia, hessian=F, integration="Simpson")
	delta.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat("  R=",delta.relative.lik[i],"\n")}

plot(delta,delta.relative.lik,type="l",xlab=expression(delta),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# skew intercept parameter in the final model.

beta0 <- seq(-2,5,by=0.2)
beta0.relative.lik <- 0*beta0

for(i in 1:length(beta0)){
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=~1, disp=~1, skew=~tim, tail=~1,
		oskew=F, iloc=ig, idisp=id, iskew=c(beta0[i],ib1),
		itail=ia, hessian=F, integration="Simpson")
	beta0.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat(i,") beta0=",beta0[i],"  R=",beta0.relative.lik[i],"\n")}

plot(beta0,beta0.relative.lik,type="l",xlab=expression(psi[0]^3),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# skew slope parameter in the final model.

beta1 <- seq(-0.5,-0.1,by=0.02)
beta1.relative.lik <- 0*beta1

for(i in 1:length(beta1)){
	cat(i,") beta1=",beta1[i])
	tamp <- stablereg(ret, delta=1/y[1:48],
		loc=~1, disp=~1, skew=~tim, tail=~1,
		oskew=F, iloc=ig, idisp=id, iskew=c(ib0,beta1[i]*100),
		itail=ia, hessian=F, integration="Simpson")
	beta1.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat("  R=",beta1.relative.lik[i],"\n")}

plot(beta1,beta1.relative.lik,type="l",xlab=expression(psi[1]^3),
	ylab="Normed profile likelihood")

# Computation of a the relative profile likelihood for the
# tail parameter in the final model

alpha <- c(1.18,seq(1.2,1.37,by=0.02),1.371430,seq(1.37,1.8,by=0.02))
alpha.relative.lik <- 0*alpha

for(i in 1:length(alpha)){
	cat(i,") tail=",alpha[i])
	tamp <- stablereg(y=ret,delta = 1/y[1:48],
		loc=~1, disp=~1, skew=~tim, tail= tail.g(alpha[i]),
		otail=F, iloc=ig, idisp=id, iskew=ib,
		hessian=F, integration="Simpson")
	alpha.relative.lik[i] <- exp(dev.opt-tamp$llik)
	cat("  R=",alpha.relative.lik[i],"\n")}

plot(alpha,alpha.relative.lik,type="l",xlab=expression(alpha),
	ylab="Normed profile likelihood")

# Final plot

postscript(file="profil2b.eps",width=6,height=9,pointsize=20)
par(mfrow=c(3,2),mar=c(5,3,2,2))
plot(alpha,alpha.relative.lik,type="l",xlab=expression(alpha),ylab="",
	xlim=c(1.1,2))
plot(alpha,alpha,type="n",bty="n",xaxt="n",yaxt="n",ann=FALSE)
plot(beta0,beta0.relative.lik,type="l",xlab=expression(psi[0]^{3}),ylab="")
plot(beta1,beta1.relative.lik,type="l",xlab=expression(psi[1]^{3}),ylab="")
plot(gamm,gamm.relative.lik,type="l",xlab=expression(gamma),ylab="")
plot(delta,delta.relative.lik,type="l",xlab=expression(delta^{121}),ylab="")
dev.off()

}
