library("stable")

y <- c(296,296,300,302,300,304,303,299,293,294,294,293,295,287,288,297,305,
307,304,303,304,304,309,309,309,307,306,304,300,296,301,298,295,
295,293,292,297,294,293,306,303,301,303,308,305,302,301,297,299)

ret <- (y[2:49]-y[1:48])/y[1:48]
hist(ret, breaks=seq(-0.035,0.045,0.01))

tim <-
c(0.00,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09,0.10,0.11,0.12,0.13,0.14,
0.15,0.16,0.17,0.18,0.19,0.20,0.21,0.22,0.23,0.24,0.25,0.26,0.27,0.28,0.29,
0.30,0.31,0.32,0.33,0.34,0.35,0.36,0.37,0.38,0.39,0.40,0.41,0.42,0.43,0.44,
0.45,0.46,0.47)

tim2 <- tim*tim
x <- seq(1,length(ret))-1


## Point estimates found by other methods
#########################################


phi.hat <- function(tt,y) mean(exp(complex(imag=y*tt)))

## Press (1972)
t1 <- 1 ; t2 <- 2
yy <- (ret-0.00053)/0.0079  # (ret-y0)/sigma0

print(alpha.hat <- log(abs(log(Mod(phi.hat(t1,yy)))/log(Mod(phi.hat(t2,yy)))))/log(abs(t1/t2)))

t1 <- 1 ; t2 <- 10
print(alpha.hat <- log(abs(log(Mod(phi.hat(t1,yy)))/log(Mod(phi.hat(t2,yy)))))/log(abs(t1/t2)))

# ====> not reliable since highly dependent o the choice of t1 and t2

## Paulson et al. (1975)
source("hermite.r")
library(stable) # provides link and inverse link functions

temp <- hermite(20)
xj <- temp[,1] ; wj <- temp[,2]

phi.hat <- function(tt,y) mean(exp(complex(imag=y*tt)))

phi <- function(tt,loc,disp,skew,tail){
  eta <- 1-abs(1-tail)
  exp.arg <- complex(imag=-skew*pi*0.5*eta*sign(tt))
  return(exp(complex(imag=loc*tt)-(abs(tt)*disp)^tail*exp(exp.arg)))}

f <- function(tt,y,loc,disp,skew,tail) {
  Mod(phi.hat(tt,y)-phi(tt,loc,disp,skew,tail))^2}

g <- function(p) {
  loc <- loc.h(p[1]) ; disp <- disp.h(p[2])
  skew <- skew.h(p[3]) ; tail <- tail.h(p[4])
  temp <- 0
  for (i in 1:20){
    temp <- temp+f(xj[i],yy,loc,disp,skew,tail)*wj[i]}
  return(temp)}

#yy <- (ret-0.0027)/0.0085
yy <- (ret-0.00053)/0.0079  # (ret-y0)/sigma0
a <- nlm(g,p=c(0,0,-0.5,0))
est <- a$estimate
cat(loc.h(est[1]),disp.h(est[2]),skew.h(est[3]),tail.h(est[4]),"\n")

> yy <- (ret-0.00053)/0.0079  # (ret-y0)/sigma0
> a <- nlm(g,p=c(0,0,-0.5,0))
> est <- a$estimate
> cat(loc.h(est[1]),disp.h(est[2]),skew.h(est[3]),tail.h(est[4]),"\n")
0.2987202 1.104675 -0.9999985 1.523452

> 0.0079*0.2987202-0.00053  sigma0*loc-y0
[1] 0.001829890

> 0.0079*1.104675           sigma0*disp
[1] 0.008726933
